#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_EXT_HOST_QUERY_RESET_SPEC_VERSION")]
pub const EXT_HOST_QUERY_RESET_SPEC_VERSION: u32 = 1;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_EXT_HOST_QUERY_RESET_EXTENSION_NAME")]
pub const EXT_HOST_QUERY_RESET_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_EXT_host_query_reset");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_RESET_QUERY_POOL_EXT: *const std::os::raw::c_char = crate::cstr!("vkResetQueryPoolEXT");
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceHostQueryResetFeaturesEXT.html)) · Alias <br/> VkPhysicalDeviceHostQueryResetFeatures - Structure describing whether queries can be reset from the host\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceHostQueryResetFeatures`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkPhysicalDeviceHostQueryResetFeatures {\n    VkStructureType    sType;\n    void*              pNext;\n    VkBool32           hostQueryReset;\n} VkPhysicalDeviceHostQueryResetFeatures;\n```\n\nor the equivalent\n\n```\n// Provided by VK_EXT_host_query_reset\ntypedef VkPhysicalDeviceHostQueryResetFeatures VkPhysicalDeviceHostQueryResetFeaturesEXT;\n```\n[](#_members)Members\n----------\n\nThis structure describes the following feature:\n[](#_description)Description\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* []() `hostQueryReset`indicates that the implementation supports resetting queries from the\n  host with [`crate::vk::PFN_vkResetQueryPool`].\n\nIf the [`crate::vk::PhysicalDeviceHostQueryResetFeatures`] structure is included in the `pNext` chain of the[`crate::vk::PhysicalDeviceFeatures2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceFeatures2`], it is filled in to indicate whether each\ncorresponding feature is supported.[`crate::vk::PhysicalDeviceHostQueryResetFeatures`] **can** also be used in the `pNext` chain of[`crate::vk::DeviceCreateInfo`] to selectively enable these features.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceHostQueryResetFeatures-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_HOST_QUERY_RESET_FEATURES`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceHostQueryResetFeaturesEXT")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceHostQueryResetFeaturesEXT = crate::vk1_2::PhysicalDeviceHostQueryResetFeatures;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkPhysicalDeviceHostQueryResetFeaturesEXT.html)) · Alias <br/> VkPhysicalDeviceHostQueryResetFeatures - Structure describing whether queries can be reset from the host\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::PhysicalDeviceHostQueryResetFeatures`] structure is defined as:\n\n```\n// Provided by VK_VERSION_1_2\ntypedef struct VkPhysicalDeviceHostQueryResetFeatures {\n    VkStructureType    sType;\n    void*              pNext;\n    VkBool32           hostQueryReset;\n} VkPhysicalDeviceHostQueryResetFeatures;\n```\n\nor the equivalent\n\n```\n// Provided by VK_EXT_host_query_reset\ntypedef VkPhysicalDeviceHostQueryResetFeatures VkPhysicalDeviceHostQueryResetFeaturesEXT;\n```\n[](#_members)Members\n----------\n\nThis structure describes the following feature:\n[](#_description)Description\n----------\n\n* `sType` is the type of this structure.\n\n* `pNext` is `NULL` or a pointer to a structure extending this\n  structure.\n\n* []() `hostQueryReset`indicates that the implementation supports resetting queries from the\n  host with [`crate::vk::PFN_vkResetQueryPool`].\n\nIf the [`crate::vk::PhysicalDeviceHostQueryResetFeatures`] structure is included in the `pNext` chain of the[`crate::vk::PhysicalDeviceFeatures2`] structure passed to[`crate::vk::PFN_vkGetPhysicalDeviceFeatures2`], it is filled in to indicate whether each\ncorresponding feature is supported.[`crate::vk::PhysicalDeviceHostQueryResetFeatures`] **can** also be used in the `pNext` chain of[`crate::vk::DeviceCreateInfo`] to selectively enable these features.\n\nValid Usage (Implicit)\n\n* []() VUID-VkPhysicalDeviceHostQueryResetFeatures-sType-sType  \n  `sType` **must** be [`crate::vk::StructureType::PHYSICAL_DEVICE_HOST_QUERY_RESET_FEATURES`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Bool32`], [`crate::vk::StructureType`]\n"]
#[doc(alias = "VkPhysicalDeviceHostQueryResetFeaturesEXT")]
#[allow(non_camel_case_types)]
pub type PhysicalDeviceHostQueryResetFeaturesEXTBuilder<'a> = crate::vk1_2::PhysicalDeviceHostQueryResetFeaturesBuilder<'a>;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkResetQueryPoolEXT.html)) · Alias <br/> vkResetQueryPool - Reset queries in a query pool\n[](#_c_specification)C Specification\n----------\n\nTo reset a range of queries in a query pool on the host, call:\n\n```\n// Provided by VK_VERSION_1_2\nvoid vkResetQueryPool(\n    VkDevice                                    device,\n    VkQueryPool                                 queryPool,\n    uint32_t                                    firstQuery,\n    uint32_t                                    queryCount);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_EXT_host_query_reset\nvoid vkResetQueryPoolEXT(\n    VkDevice                                    device,\n    VkQueryPool                                 queryPool,\n    uint32_t                                    firstQuery,\n    uint32_t                                    queryCount);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that owns the query pool.\n\n* `queryPool` is the handle of the query pool managing the queries\n  being reset.\n\n* `firstQuery` is the initial query index to reset.\n\n* `queryCount` is the number of queries to reset.\n[](#_description)Description\n----------\n\nThis command sets the status of query indices [`firstQuery`,`firstQuery` + `queryCount` - 1] to unavailable.\n\nIf `queryPool` is [`crate::vk::QueryType::PERFORMANCE_QUERY_KHR`] this command\nsets the status of query indices [`firstQuery`, `firstQuery`+ `queryCount` - 1] to unavailable for each pass.\n\nValid Usage\n\n* []() VUID-vkResetQueryPool-None-02665  \n   The [hostQueryReset](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-hostQueryReset) feature **must** be enabled\n\n* []() VUID-vkResetQueryPool-firstQuery-02666  \n  `firstQuery` **must** be less than the number of queries in`queryPool`\n\n* []() VUID-vkResetQueryPool-firstQuery-02667  \n   The sum of `firstQuery` and `queryCount` **must** be less than or\n  equal to the number of queries in `queryPool`\n\n* []() VUID-vkResetQueryPool-firstQuery-02741  \n   Submitted commands that refer to the range specified by `firstQuery`and `queryCount` in `queryPool` **must** have completed execution\n\n* []() VUID-vkResetQueryPool-firstQuery-02742  \n   The range of queries specified by `firstQuery` and `queryCount`in `queryPool` **must** not be in use by calls to[`crate::vk::PFN_vkGetQueryPoolResults`] or [`crate::vk::PFN_vkResetQueryPool`] in other threads\n\nValid Usage (Implicit)\n\n* []() VUID-vkResetQueryPool-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkResetQueryPool-queryPool-parameter  \n  `queryPool` **must** be a valid [`crate::vk::QueryPool`] handle\n\n* []() VUID-vkResetQueryPool-queryPool-parent  \n  `queryPool` **must** have been created, allocated, or retrieved from `device`\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::QueryPool`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkResetQueryPoolEXT = crate::vk1_2::PFN_vkResetQueryPool;
#[doc = "Provided by [`crate::extensions::ext_host_query_reset`]"]
impl crate::vk1_0::StructureType {
    pub const PHYSICAL_DEVICE_HOST_QUERY_RESET_FEATURES_EXT: Self = Self::PHYSICAL_DEVICE_HOST_QUERY_RESET_FEATURES;
}
#[doc = "Provided by [`crate::extensions::ext_host_query_reset`]"]
impl crate::DeviceLoader {
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkResetQueryPoolEXT.html)) · Function <br/> vkResetQueryPool - Reset queries in a query pool\n[](#_c_specification)C Specification\n----------\n\nTo reset a range of queries in a query pool on the host, call:\n\n```\n// Provided by VK_VERSION_1_2\nvoid vkResetQueryPool(\n    VkDevice                                    device,\n    VkQueryPool                                 queryPool,\n    uint32_t                                    firstQuery,\n    uint32_t                                    queryCount);\n```\n\nor the equivalent command\n\n```\n// Provided by VK_EXT_host_query_reset\nvoid vkResetQueryPoolEXT(\n    VkDevice                                    device,\n    VkQueryPool                                 queryPool,\n    uint32_t                                    firstQuery,\n    uint32_t                                    queryCount);\n```\n[](#_parameters)Parameters\n----------\n\n* `device` is the logical device that owns the query pool.\n\n* `queryPool` is the handle of the query pool managing the queries\n  being reset.\n\n* `firstQuery` is the initial query index to reset.\n\n* `queryCount` is the number of queries to reset.\n[](#_description)Description\n----------\n\nThis command sets the status of query indices [`firstQuery`,`firstQuery` + `queryCount` - 1] to unavailable.\n\nIf `queryPool` is [`crate::vk::QueryType::PERFORMANCE_QUERY_KHR`] this command\nsets the status of query indices [`firstQuery`, `firstQuery`+ `queryCount` - 1] to unavailable for each pass.\n\nValid Usage\n\n* []() VUID-vkResetQueryPool-None-02665  \n   The [hostQueryReset](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#features-hostQueryReset) feature **must** be enabled\n\n* []() VUID-vkResetQueryPool-firstQuery-02666  \n  `firstQuery` **must** be less than the number of queries in`queryPool`\n\n* []() VUID-vkResetQueryPool-firstQuery-02667  \n   The sum of `firstQuery` and `queryCount` **must** be less than or\n  equal to the number of queries in `queryPool`\n\n* []() VUID-vkResetQueryPool-firstQuery-02741  \n   Submitted commands that refer to the range specified by `firstQuery`and `queryCount` in `queryPool` **must** have completed execution\n\n* []() VUID-vkResetQueryPool-firstQuery-02742  \n   The range of queries specified by `firstQuery` and `queryCount`in `queryPool` **must** not be in use by calls to[`crate::vk::PFN_vkGetQueryPoolResults`] or [`crate::vk::PFN_vkResetQueryPool`] in other threads\n\nValid Usage (Implicit)\n\n* []() VUID-vkResetQueryPool-device-parameter  \n  `device` **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkResetQueryPool-queryPool-parameter  \n  `queryPool` **must** be a valid [`crate::vk::QueryPool`] handle\n\n* []() VUID-vkResetQueryPool-queryPool-parent  \n  `queryPool` **must** have been created, allocated, or retrieved from `device`\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::QueryPool`]\n"]
    #[doc(alias = "vkResetQueryPoolEXT")]
    pub unsafe fn reset_query_pool_ext(&self, query_pool: crate::vk1_0::QueryPool, first_query: u32, query_count: u32) -> () {
        let _function = self.reset_query_pool_ext.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(self.handle, query_pool as _, first_query as _, query_count as _);
        ()
    }
}
